// Generated from java-escape by ANTLR 4.11.1

    package antlr4;

import org.antlr.v4.runtime.tree.ParseTreeVisitor;

/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by {@link Pcl5Parser}.
 *
 * @param <T> The return type of the visit operation. Use {@link Void} for
 * operations with no return type.
 */
public interface Pcl5Visitor<T> extends ParseTreeVisitor<T> {
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#program}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProgram(Pcl5Parser.ProgramContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#programHeader}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProgramHeader(Pcl5Parser.ProgramHeaderContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#programParameters}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProgramParameters(Pcl5Parser.ProgramParametersContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#block}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitBlock(Pcl5Parser.BlockContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#declarations}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDeclarations(Pcl5Parser.DeclarationsContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#constantsPart}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConstantsPart(Pcl5Parser.ConstantsPartContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#constantDefinitionsList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConstantDefinitionsList(Pcl5Parser.ConstantDefinitionsListContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#constantDefinition}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConstantDefinition(Pcl5Parser.ConstantDefinitionContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#constantIdentifier}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConstantIdentifier(Pcl5Parser.ConstantIdentifierContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#constant}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConstant(Pcl5Parser.ConstantContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#typesPart}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTypesPart(Pcl5Parser.TypesPartContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#typeDefinitionsList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTypeDefinitionsList(Pcl5Parser.TypeDefinitionsListContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#typeDefinition}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTypeDefinition(Pcl5Parser.TypeDefinitionContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#typeIdentifier}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTypeIdentifier(Pcl5Parser.TypeIdentifierContext ctx);
	/**
	 * Visit a parse tree produced by the {@code simpleTypespec}
	 * labeled alternative in {@link Pcl5Parser#typeSpecification}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSimpleTypespec(Pcl5Parser.SimpleTypespecContext ctx);
	/**
	 * Visit a parse tree produced by the {@code arrayTypespec}
	 * labeled alternative in {@link Pcl5Parser#typeSpecification}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitArrayTypespec(Pcl5Parser.ArrayTypespecContext ctx);
	/**
	 * Visit a parse tree produced by the {@code recordTypespec}
	 * labeled alternative in {@link Pcl5Parser#typeSpecification}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRecordTypespec(Pcl5Parser.RecordTypespecContext ctx);
	/**
	 * Visit a parse tree produced by the {@code typeIdentifierTypespec}
	 * labeled alternative in {@link Pcl5Parser#simpleType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTypeIdentifierTypespec(Pcl5Parser.TypeIdentifierTypespecContext ctx);
	/**
	 * Visit a parse tree produced by the {@code enumerationTypespec}
	 * labeled alternative in {@link Pcl5Parser#simpleType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitEnumerationTypespec(Pcl5Parser.EnumerationTypespecContext ctx);
	/**
	 * Visit a parse tree produced by the {@code subrangeTypespec}
	 * labeled alternative in {@link Pcl5Parser#simpleType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSubrangeTypespec(Pcl5Parser.SubrangeTypespecContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#enumerationType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitEnumerationType(Pcl5Parser.EnumerationTypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#enumerationConstant}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitEnumerationConstant(Pcl5Parser.EnumerationConstantContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#subrangeType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSubrangeType(Pcl5Parser.SubrangeTypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#arrayType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitArrayType(Pcl5Parser.ArrayTypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#arrayDimensionList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitArrayDimensionList(Pcl5Parser.ArrayDimensionListContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#recordType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRecordType(Pcl5Parser.RecordTypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#recordFields}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRecordFields(Pcl5Parser.RecordFieldsContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#variablesPart}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariablesPart(Pcl5Parser.VariablesPartContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#variableDeclarationsList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariableDeclarationsList(Pcl5Parser.VariableDeclarationsListContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#variableDeclarations}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariableDeclarations(Pcl5Parser.VariableDeclarationsContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#variableIdentifierList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariableIdentifierList(Pcl5Parser.VariableIdentifierListContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#variableIdentifier}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariableIdentifier(Pcl5Parser.VariableIdentifierContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#routinesPart}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRoutinesPart(Pcl5Parser.RoutinesPartContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#statement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStatement(Pcl5Parser.StatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#compoundStatement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCompoundStatement(Pcl5Parser.CompoundStatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#emptyStatement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitEmptyStatement(Pcl5Parser.EmptyStatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#statementList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStatementList(Pcl5Parser.StatementListContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#assignmentStatement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAssignmentStatement(Pcl5Parser.AssignmentStatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#repeatStatement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRepeatStatement(Pcl5Parser.RepeatStatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#lhs}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitLhs(Pcl5Parser.LhsContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#rhs}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRhs(Pcl5Parser.RhsContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#writeStatement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWriteStatement(Pcl5Parser.WriteStatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#writelnStatement}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWritelnStatement(Pcl5Parser.WritelnStatementContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#expression}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExpression(Pcl5Parser.ExpressionContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#simpleExpression}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSimpleExpression(Pcl5Parser.SimpleExpressionContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#term}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTerm(Pcl5Parser.TermContext ctx);
	/**
	 * Visit a parse tree produced by the {@code variableFactor}
	 * labeled alternative in {@link Pcl5Parser#factor}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariableFactor(Pcl5Parser.VariableFactorContext ctx);
	/**
	 * Visit a parse tree produced by the {@code numberFactor}
	 * labeled alternative in {@link Pcl5Parser#factor}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitNumberFactor(Pcl5Parser.NumberFactorContext ctx);
	/**
	 * Visit a parse tree produced by the {@code characterFactor}
	 * labeled alternative in {@link Pcl5Parser#factor}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCharacterFactor(Pcl5Parser.CharacterFactorContext ctx);
	/**
	 * Visit a parse tree produced by the {@code stringFactor}
	 * labeled alternative in {@link Pcl5Parser#factor}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStringFactor(Pcl5Parser.StringFactorContext ctx);
	/**
	 * Visit a parse tree produced by the {@code notFactor}
	 * labeled alternative in {@link Pcl5Parser#factor}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitNotFactor(Pcl5Parser.NotFactorContext ctx);
	/**
	 * Visit a parse tree produced by the {@code parenthesizedFactor}
	 * labeled alternative in {@link Pcl5Parser#factor}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitParenthesizedFactor(Pcl5Parser.ParenthesizedFactorContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#variable}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariable(Pcl5Parser.VariableContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#number}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitNumber(Pcl5Parser.NumberContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#unsignedNumber}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitUnsignedNumber(Pcl5Parser.UnsignedNumberContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#integerConstant}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIntegerConstant(Pcl5Parser.IntegerConstantContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#realConstant}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRealConstant(Pcl5Parser.RealConstantContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#characterConstant}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCharacterConstant(Pcl5Parser.CharacterConstantContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#stringConstant}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStringConstant(Pcl5Parser.StringConstantContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#sign}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSign(Pcl5Parser.SignContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#relOp}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRelOp(Pcl5Parser.RelOpContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#addOp}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAddOp(Pcl5Parser.AddOpContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#mulOp}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMulOp(Pcl5Parser.MulOpContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#writeArguments}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWriteArguments(Pcl5Parser.WriteArgumentsContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#writeArgument}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWriteArgument(Pcl5Parser.WriteArgumentContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#fieldWidth}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitFieldWidth(Pcl5Parser.FieldWidthContext ctx);
	/**
	 * Visit a parse tree produced by {@link Pcl5Parser#decimalPlaces}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDecimalPlaces(Pcl5Parser.DecimalPlacesContext ctx);
}